﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using UnivateProperties_API.Model.Properties;

namespace UnivateProperties_API.Containers.Property
{
    public class PropertyContainer : Model.Properties.Property
    {
        public int UserId { get; set; }
        public string PropertyUsageType { get; set; }
        public List<NewImage> NewImages { get; set; }
        public List<PropertyFieldGroup> PropertyOverviewFields { get; set; }
        public List<PropertyFieldGroup> PropertyFields { get; set; }
    }

    public class PropertyFieldGroup
    {
        public string Name { get; set; }
        public List<PropertyFieldEdit> Fields { get; set; }
    }

    public class PropertyFieldEdit
    {
        public int Id { get; set; }
        public string Name { get; set; }
        public string Type { get; set; }
        public string Value { get; set; }
        public int ItemId { get; set; }
    }

    public class NewPropertyImages
    {
        public int PropertyId { get; set; }
        public List<NewImage> Images { get; set; }
    }

    public class NewImage
    {        
        public string Image { get; set;  }
        public bool IsDefault { get; set; }
    }

    public class PropertyImageContainer
    {
        public int PropertyId { get; set; }
        public List<PropertyImage> Images { get; set; }
    }
}
