﻿using JetBrains.Annotations;
using Org.BouncyCastle.Asn1.Mozilla;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using UnivateProperties_API.Model.Misc;
using UnivateProperties_API.Model.Timeshare;

namespace UnivateProperties_API.Containers.Timeshare
{
    public class TimeshareWeekDto : TimeshareWeek
    {
        public OwnerObject OwnerObject { get; set; }
    }

    public class OwnerObject
    {
        public int Id { get; set; }
        public string Name { get; set; }
        public string Surname { get; set; }
        public string IdNumber { get; set; }
        public string CompanyRegNumber { get; set; }
        public string MaritalStatus { get; set; }
        public string EmailAddress { get; set; }
        public string CellNumber { get; set; }
        public string LandlineNumber { get; set; }
        public string SpouseName { get; set; }
        public string SpouseSurname { get; set; }
        public string SpouseEmail { get; set; }
        public string SpouseTelephone { get; set; }
        public string SpouseCellnumber { get; set; }
        public OwnerAddress Address { get; set; }
        public OnwerBankingDetails BankingDetails { get; set; }
    }

    public class OwnerAddress
    {
        public int Id { get; set; }
        public string StreetNumber { get; set; }
        public string Street { get; set; }
        public string Suburb { get; set; }
        public string City { get; set; }
        public string Province { get; set; }
        public string PostalCode { get; set; }
    }

    public class OnwerBankingDetails
    {
        public int Id { get; set; }
        public string AccountNumber { get; set; }
        public string AccountHolder { get; set; }
        public OwnerBank Bank { get; set; }
    }

    public class OwnerBank
    {
        public string Name { get; set;  }
        public string UniversalBranchCode { get; set; }
        public int Id { get; set; }        
    }
}
